package provide DS9 1.0

proc PolygonDialog {frame id} {
    global marker

    # see if we already have a header window visible

    set w ".marker$id"
    set mb ".mb$id"

    if [winfo exist $w] {
	raise $w
	return
    }

    # Init common items

    InitMarkerDialog $frame $id
    PropMenuPolygonDialog $frame $mb $id
    CoordMenuMarkerDialog $frame $mb $id CoordPolygonCB
    CoordMarkerCB $frame $id

    # file menu items

    $mb.file add command -label "Apply" \
	-command "ApplyPolygonDialog $frame $id"
    $mb.file add separator
    $mb.file add command -label "Close" \
	-command "ClosePolygonDialog $frame $id"

    # Init polygon variables

    EditPolygonCB $frame $id
    RotateMarkerCB $frame $id

    # polygon specific callbacks

    $frame marker $id callback edit EditPolygonCB $frame
    $frame marker $id callback rotate RotateMarkerCB $frame
    $frame marker $id callback delete DeletePolygonDialog $frame

    # Dialog

    CommonMarkerDialog $frame $id
    wm protocol $w WM_DELETE_WINDOW "ClosePolygonDialog $frame $id"

    label $w.ref.f.angleTitle -text "Angle"
    entry $w.ref.f.angle -textvariable marker($frame,$id,angle) \
	-width 13 -relief sunken -bd 2
    label $w.ref.f.angleUnit -relief groove -bd 2 -width 9 -padx 4 \
	-text "degrees"

    grid $w.ref.f.angleTitle $w.ref.f.angle x $w.ref.f.angleUnit \
	-padx 4 -sticky w

    # Buttons

    button $w.buttons.apply -text "Apply" \
	-command "ApplyPolygonDialog $frame $id"
    button $w.buttons.close -text "Close" \
	-command "ClosePolygonDialog $frame $id"
    pack $w.buttons.apply $w.buttons.close -side left -padx 10 -expand true

    bind $w <Return> "ApplyPolygonDialog $frame $id"
}

proc ApplyPolygonDialog {frame id} {
    EditPolygonDialog $frame $id
    RotateMarkerDialog $frame $id
    ApplyMarkerDialog $frame $id
}

proc ClosePolygonDialog {frame id} {
    global marker

    $frame marker $id delete callback edit EditPolygonCB
    $frame marker $id delete callback rotate RotateMarkerCB
    $frame marker $id delete callback delete DeletePolygonDialog
    DeleteMarkerCBs $frame $id

    DeletePolygonDialog $frame $id
}

proc DeletePolygonDialog {frame id} {
    global marker

    DeleteMarkerDialog $frame $id

    unset marker($frame,$id,angle)
}

proc EditPolygonDialog {frame id} {
}

proc EditPolygonCB {frame id} {
}

proc CoordPolygonCB {frame id} {
    CoordMarkerCB $frame $id

    MoveMarkerCB $frame $id
    RotateMarkerCB $frame $id
}

proc PropMenuPolygonDialog {frame mb id} {
    global menu
    global marker

    menu $mb.properties -tearoff 0 -selectcolor $menu(selectcolor)
    $mb.properties add checkbutton -label "Can Edit" \
	-variable marker($frame,$id,edit) \
	-command "PropertyMarkerDialog $frame $id edit"
    $mb.properties add checkbutton -label "Can Move" \
	-variable marker($frame,$id,move) \
	-command "PropertyMarkerDialog $frame $id move"
    $mb.properties add checkbutton -label "Can Rotate" \
	-variable marker($frame,$id,rotate) \
	-command "PropertyMarkerDialog $frame $id rotate"
    $mb.properties add checkbutton -label "Can Delete" \
	-variable marker($frame,$id,delete) \
	-command "PropertyMarkerDialog $frame $id delete"
    $mb.properties add separator
    $mb.properties add radiobutton -label Include \
	-variable marker($frame,$id,include) -value 1 \
	-command "PropertyMarkerDialog $frame $id include"
    $mb.properties add radiobutton -label Exclude \
	-variable marker($frame,$id,include) -value 0 \
	-command "PropertyMarkerDialog $frame $id include"
    $mb.properties add separator
    $mb.properties add radiobutton -label Source \
	-variable marker($frame,$id,source) -value 1 \
	-command "PropertyMarkerDialog $frame $id source"
    $mb.properties add radiobutton -label Background \
	-variable marker($frame,$id,source) -value 0 \
	-command "PropertyMarkerDialog $frame $id source"
}

