#! /bin/sh

#linux commands
#ipcs -m
#ipcs -ml
#ipcrm shm <shmid>
#echo '67108864' > /proc/sys/kernel/shmmax

KillIt () {
    i=1
    while [ "$i" -le 15 ]
    do
        sleep 1
        if [ `xpaaccess ds9` = yes ]
        then
	    sleep 1
	    xpaset -p ds9 quit
	    break
        fi

        i=`expr $i + 1`
    done
}

DoXPA () {
    echo "$1"
    shmid=`shmload -q $2`
    xpaset -p ds9 shm $3 shmid $shmid $4
    sleep 1
    xpaset -p ds9 frame clear
    ipcrm -m $shmid
}

DoCmd () {
    echo "$1"
    shmid=`shmload -q $2`
    ../ds9 -zscale -shm $3 shmid $shmid $4 &
    KillIt
    ipcrm -m $shmid
}

DoCmd2 () {
    echo "$1"
    shmid=`shmload -q $2`
    ../ds9 -shm $3 shmid $shmid $4 &
    KillIt
    ipcrm -m $shmid
}

echo "Current shm limits"
ipcs -lm

if [ "$1" = "command" -o  -z "$1" ]; then
echo "Command Line Shm Tests"

DoCmd "..fits" img16.fits "" foo
DoCmd "..fits gz" img16.fits "" foo
DoCmd "..table" table.fits "" foo
DoCmd "..table filter" table.fits "" 'foo[bin=rawx,rawy]'
DoCmd "..array" array.arr array 'foo[dim=512,bitpix=-32,arch=bigendian]'
DoCmd "..array cube" cube.arr array 'foo[dim=512,zdim=3,bitpix=-32,arch=bigendian]'
DoCmd "..mosaic image iraf" mosaicimage.fits mosaicimageiraf foo
DoCmd "..mosaic iraf" mosaicimage.fits mosaiciraf foo
DoCmd "..mosaic image wcs" mosaicimage.fits mosaicimagewcs foo
DoCmd "..mosaic wcs" mosaicimage.fits mosaicwcs foo
DoCmd "..mosaic image wfpc2" hst.fits mosaicimagewfpc2 foo
DoCmd2 "..rgbcube" rgbcube.fits rgbcube foo
DoCmd2 "..rgbimage" rgbimage.fits rgbimage foo

echo "PASSED"
fi

if [ "$1" = "xpa" -o  -z "$1" ]; then
echo "XPA Shm Tests"

echo "Starting DS9..."
if [ `xpaaccess ds9` = no ]
then
    ../ds9&
fi

i=1
while [ "$i" -le 15 ]
do
    sleep 1
    if [ `xpaaccess ds9` = yes ]
    then
	break
    fi

    i=`expr $i + 1`
done

xpaset -p ds9 scale zscale

DoXPA "..fits" img16.fits "" foo
DoXPA "..fits gz" img16.fits "" foo
DoXPA "..table" table.fits "" foo
DoXPA "..table filter" table.fits "" 'foo[bin=rawx,rawy]'
DoXPA "..array" array.arr array 'foo[dim=512,bitpix=-32,arch=bigendian]'
DoXPA "..array cube" cube.arr array 'foo[dim=512,bitpix=-32,zdim=3,arch=bigendian]'
DoXPA "..mosaic image iraf" mosaicimage.fits mosaicimageiraf foo
DoXPA "..mosaic iraf" mosaicimage.fits mosaiciraf foo
DoXPA "..mosaic image wcs" mosaicimage.fits mosaicimagewcs foo
DoXPA "..mosaic wcs" mosaicimage.fits mosaicwcs foo
DoXPA "..mosaic image wfpc2" hst.fits mosaicimagewfpc2 foo

xpaset -p ds9 scale minmax
xpaset -p ds9 rgb
DoXPA "..rgbcube" rgbcube.fits rgbcube foo
DoXPA "..rgbimage" rgbimage.fits rgbimage foo

xpaset -p ds9 quit
echo "PASSED"
fi

echo "DONE"



