/*
 *
 * swap.h -- declarations for swap
 *
 */

#include <prsetup.h>

/*
 *      Copyrights:
 *
 *    	      Copyright (c) 1996 Smithsonian Astrophysical Observatory
 *
 *        Permission to use, copy, modify, distribute, and  sell  this
 *        software  and  its  documentation  for any purpose is hereby
 *        granted without  fee,  provided  that  the  above  copyright
 *        notice  appear  in  all  copies and that both that copyright
 *        notice and this permission notice appear in supporting docu-
 *        mentation,  and  that  the  name  of the  Smithsonian Astro-
 *	  physical Observatory not be used in advertising or publicity
 *  	  pertaining to distribution of the software without specific,
 *	  written  prior  permission.   The Smithsonian  Astrophysical 
 *        Observatory makes no representations about  the  suitability
 *	  of  this  software for any purpose.  It is provided  "as is"
 *	  without express or implied warranty.
 *        THE  SMITHSONIAN  ASTROPHYSICAL  OBSERVATORY  DISCLAIMS  ALL
 *	  WARRANTIES  WITH  REGARD  TO  THIS  SOFTWARE,  INCLUDING ALL
 *	  IMPLIED  WARRANTIES  OF  MERCHANTABILITY AND FITNESS, IN  NO
 *	  EVENT SHALL THE  SMITHSONIAN  ASTROPHYSICAL  OBSERVATORY  BE 
 *	  LIABLE FOR  ANY SPECIAL, INDIRECT  OR  CONSEQUENTIAL DAMAGES
 *	  OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS  OF USE,  DATA
 *	  OR  PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
 *	  OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION  WITH
 *	  THE  USE OR PERFORMANCE OF THIS SOFTWARE.
 *
 */

#ifndef NewString
#define NewString(str) \
    ((str) != (char *)NULL ? ((char *)strcpy((char *)malloc((unsigned)strlen(str) + 1), str)) : (char *)NULL)

#ifndef SZ_LINE
#define SZ_LINE 160
#endif
#endif

#ifndef MIN
#define MIN(a,b) (((a)<(b))?(a):(b))
#endif

#ifndef MAX
#define MAX(a,b) (((a)>(b))?(a):(b))
#endif

#ifndef ABS
#define ABS(x) ((x)<0?(-x):(x))
#endif

/* data types */
#define TY_CHAR		1
#define TY_USHORT	-2
#define TY_SHORT	2
#define TY_INT		4
#define TY_FLOAT	-4
#define TY_DOUBLE	-8

_PRbeg

int is_bigendian _PRx((void));
void swap_short _PRx((short *buf, int n));
void swap_ushort _PRx((unsigned short *buf, int n));
void swap_int _PRx((int *buf, int n));
void swap_uint _PRx((unsigned int *buf, int n));
void swap_float _PRx((float *buf, int n));
void swap_double _PRx((double *buf, int n));
void swap_data _PRx((void *buf, int len, int dtype));

_PRend

