#ifndef __fitsmapincr_h__
#define __fitsmapincr_h__

#include "file.h"

class FitsMapIncr : public FitsFile {
protected:
  int fd_; // file descripter
  off_t filesize_; // size of the total segment
  off_t seek_; // offset into segment

  FitsHead* hduRead();

public:
  FitsMapIncr();
  virtual ~FitsMapIncr();

  int fd() {return fd_;}
  off_t filesize() {return filesize_;}
  off_t seek() {return seek_;}
};

class FitsFitsMapIncr : public virtual FitsMapIncr {
protected:
  void processExact();
  void processRelax();

public:
  FitsFitsMapIncr(ScanMode);
};

class FitsFitsNextMapIncr : public FitsMapIncr {
public:
  FitsFitsNextMapIncr(FitsFile* prev);
};

class FitsArrMapIncr : public virtual FitsMapIncr {
public:
  FitsArrMapIncr();
};

class FitsMosaicMapIncr : public virtual FitsMapIncr {
public:
  FitsMosaicMapIncr();
};

class FitsMosaicNextMapIncr : public FitsMapIncr {
public:
  FitsMosaicNextMapIncr(FitsFile* prev);
};

#endif








