#ifndef __fvcontour_h__
#define __fvcontour_h__

#include "vector.h"
#include "contour.h"

class FVContour : public Contour {
 private:
  enum {top, right, bottom, left, none};

  float resolution;

  void unity(FitsImage*);
  void bin(FitsImage*);
  void smooth(FitsImage*);
  int build(int xdim, int ydim, float *image, Matrix&);
  int trace(int xdim, int ydim, float cntr,
	    int xCell, int yCell, int side,
	    float** rows, char* useGrid, Matrix&);

public:
  FVContour(FrameBase*, FitsImage*, const char*, int, float, int, ContourScale*);

  void append(FitsImage*);
};

#endif
